machine Client
{
    var s: Shard;
    var objects: set[tObject];

    start state Init {
        entry (input : (s: Shard, pool: set[tObject]))
        {
            s = input.s;
            objects = input.pool;
            goto DoSomething;
        }
    }

    state DoSomething {
        entry {
            var obj: tObject;
            var op: int;
            while (0 < sizeof(objects)) {
                obj = choose(objects);
                send s, eShardReqPut, (source = this, obj = obj);
                receive {
                    case eShardResPut: (res: tShardResPut) {}
                }
                send s, eShardReqDel, (source = this, address = obj.address);
                receive {
                    case eShardResDel: (res: tShardResDel) {}
                }
                send s, eShardReqExists, (source = this, address = obj.address);
                receive {
                    case eShardResExists: (res: tShardResExists) {}
                }
                objects -= (obj);
            }
        }
    }
}
